/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.279 Revision 1.369
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.279 2007/04/25 09:14:35 carlo Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.369 2011/12/02 03:27:37 vapier Exp $
4#
5# This eclass is for general purpose functions that most ebuilds
6# have to implement themselves.
7#
8# NB: If you add anything, please comment it!
9#
10# Maintainer: see each individual function, base-system@gentoo.org as default
11 4
5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
17
12inherit multilib portability 18inherit multilib portability user
13 19
14DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
15 21
16# Wait for the supplied number of seconds. If no argument is supplied, defaults 22if has "${EAPI:-0}" 0 1 2; then
17# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 23
18# outputting to a terminal, don't wait. For compatability purposes, the argument 24# @FUNCTION: epause
19# must be an integer greater than zero. 25# @USAGE: [seconds]
20# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 26# @DESCRIPTION:
27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
28# printing a message the user should probably be reading and often used in
29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
30# don't wait at all. Defined in EAPIs 0 1 and 2.
21epause() { 31epause() {
22 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
23} 33}
24 34
25# Beep the specified number of times (defaults to five). If our output 35# @FUNCTION: ebeep
26# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 36# @USAGE: [number of beeps]
27# don't beep. 37# @DESCRIPTION:
28# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 38# Issue the specified number of beeps (default of 5 beeps). Useful when
39# printing a message the user should probably be reading and often used in
40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
41# don't beep at all. Defined in EAPIs 0 1 and 2.
29ebeep() { 42ebeep() {
30 local n 43 local n
31 if [[ -z ${EBEEP_IGNORE} ]] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
32 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
33 echo -ne "\a" 46 echo -ne "\a"
36 sleep 1 49 sleep 1
37 done 50 done
38 fi 51 fi
39} 52}
40 53
41# This function generate linker scripts in /usr/lib for dynamic 54else
42# libs in /lib. This is to fix linking problems when you have 55
43# the .so in /lib, and the .a in /usr/lib. What happens is that 56ebeep() {
44# in some cases when linking dynamic, the .a in /usr/lib is used 57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
45# instead of the .so in /lib due to gcc/libtool tweaking ld's 58}
46# library search path. This cause many builds to fail. 59
47# See bug #4411 for more info. 60epause() {
48# 61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
49# To use, simply call: 62}
50# 63
51# gen_usr_ldscript libfoo.so
52#
53# Note that you should in general use the unversioned name of
54# the library, as ldconfig should usually update it correctly
55# to point to the latest version of the library present.
56#
57# <azarah@gentoo.org> (26 Oct 2002)
58#
59gen_usr_ldscript() {
60 if [[ $(type -t _tc_gen_usr_ldscript) == "function" ]] ; then
61 _tc_gen_usr_ldscript "$@"
62 return $?
63 fi 64fi
64 65
65 ewarn "QA Notice: Please upgrade your ebuild to use toolchain-funcs" 66# @FUNCTION: eqawarn
66 ewarn "QA Notice: rather than gen_usr_ldscript() from eutils" 67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
70# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
71# profile.
72if ! declare -F eqawarn >/dev/null ; then
73 eqawarn() {
74 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
75 }
76fi
67 77
68 local lib libdir=$(get_libdir) 78# @FUNCTION: ecvs_clean
69 # Just make sure it exists 79# @USAGE: [list of dirs]
70 dodir /usr/${libdir} 80# @DESCRIPTION:
81# Remove CVS directories recursiveley. Useful when a source tarball contains
82# internal CVS directories. Defaults to $PWD.
83ecvs_clean() {
84 [[ -z $* ]] && set -- .
85 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
86 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
87}
71 88
72 for lib in "${@}" ; do 89# @FUNCTION: esvn_clean
73 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 90# @USAGE: [list of dirs]
74 /* GNU ld script 91# @DESCRIPTION:
75 Since Gentoo has critical dynamic libraries 92# Remove .svn directories recursiveley. Useful when a source tarball contains
76 in /lib, and the static versions in /usr/lib, 93# internal Subversion directories. Defaults to $PWD.
77 we need to have a "fake" dynamic lib in /usr/lib, 94esvn_clean() {
78 otherwise we run into linking problems. 95 [[ -z $* ]] && set -- .
96 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
97}
79 98
80 See bug http://bugs.gentoo.org/4411 for more info. 99# @FUNCTION: eshopts_push
81 */ 100# @USAGE: [options to `set` or `shopt`]
82 GROUP ( /${libdir}/${lib} ) 101# @DESCRIPTION:
83 END_LDSCRIPT 102# Often times code will want to enable a shell option to change code behavior.
84 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 103# Since changing shell options can easily break other pieces of code (which
104# assume the default state), eshopts_push is used to (1) push the current shell
105# options onto a stack and (2) pass the specified arguments to set.
106#
107# If the first argument is '-s' or '-u', we assume you want to call `shopt`
108# rather than `set` as there are some options only available via that.
109#
110# A common example is to disable shell globbing so that special meaning/care
111# may be used with variables/arguments to custom functions. That would be:
112# @CODE
113# eshopts_push -o noglob
114# for x in ${foo} ; do
115# if ...some check... ; then
116# eshopts_pop
117# return 0
118# fi
85 done 119# done
120# eshopts_pop
121# @CODE
122eshopts_push() {
123 # have to assume __ESHOPTS_SAVE__ isn't screwed with
124 # as a `declare -a` here will reset its value
125 local i=${#__ESHOPTS_SAVE__[@]}
126 if [[ $1 == -[su] ]] ; then
127 __ESHOPTS_SAVE__[$i]=$(shopt -p)
128 [[ $# -eq 0 ]] && return 0
129 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
130 else
131 __ESHOPTS_SAVE__[$i]=$-
132 [[ $# -eq 0 ]] && return 0
133 set "$@" || die "eshopts_push: bad options to set: $*"
134 fi
86} 135}
87 136
137# @FUNCTION: eshopts_pop
138# @USAGE:
139# @DESCRIPTION:
140# Restore the shell options to the state saved with the corresponding
141# eshopts_push call. See that function for more details.
142eshopts_pop() {
143 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
144 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
145 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
146 local s=${__ESHOPTS_SAVE__[$i]}
147 unset __ESHOPTS_SAVE__[$i]
148 if [[ ${s} == "shopt -"* ]] ; then
149 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
150 else
151 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
152 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
153 fi
154}
88 155
89# Default directory where patches are located 156# @VARIABLE: EPATCH_SOURCE
157# @DESCRIPTION:
158# Default directory to search for patches.
90EPATCH_SOURCE="${WORKDIR}/patch" 159EPATCH_SOURCE="${WORKDIR}/patch"
91# Default extension for patches 160# @VARIABLE: EPATCH_SUFFIX
161# @DESCRIPTION:
162# Default extension for patches (do not prefix the period yourself).
92EPATCH_SUFFIX="patch.bz2" 163EPATCH_SUFFIX="patch.bz2"
164# @VARIABLE: EPATCH_OPTS
165# @DESCRIPTION:
93# Default options for patch 166# Default options for patch:
167# @CODE
94# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 168# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
95# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 169# --no-backup-if-mismatch - do not leave .orig files behind
96# Set -E to automatically remove empty files. 170# -E - automatically remove empty files
171# @CODE
97EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 172EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
173# @VARIABLE: EPATCH_EXCLUDE
174# @DESCRIPTION:
98# List of patches not to apply. Not this is only file names, 175# List of patches not to apply. Note this is only file names,
99# and not the full path .. 176# and not the full path. Globs accepted.
100EPATCH_EXCLUDE="" 177EPATCH_EXCLUDE=""
178# @VARIABLE: EPATCH_SINGLE_MSG
179# @DESCRIPTION:
101# Change the printed message for a single patch. 180# Change the printed message for a single patch.
102EPATCH_SINGLE_MSG="" 181EPATCH_SINGLE_MSG=""
182# @VARIABLE: EPATCH_MULTI_MSG
183# @DESCRIPTION:
103# Change the printed message for multiple patches. 184# Change the printed message for multiple patches.
104EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 185EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
105# Force applying bulk patches even if not following the style: 186# @VARIABLE: EPATCH_FORCE
106# 187# @DESCRIPTION:
107# ??_${ARCH}_foo.${EPATCH_SUFFIX} 188# Only require patches to match EPATCH_SUFFIX rather than the extended
108# 189# arch naming style.
109EPATCH_FORCE="no" 190EPATCH_FORCE="no"
110 191
111# This function is for bulk patching, or in theory for just one 192# @FUNCTION: epatch
112# or two patches. 193# @USAGE: [patches] [dirs of patches]
194# @DESCRIPTION:
195# epatch is designed to greatly simplify the application of patches. It can
196# process patch files directly, or directories of patches. The patches may be
197# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
198# the -p option as epatch will automatically attempt -p0 to -p5 until things
199# apply successfully.
113# 200#
114# It should work with .bz2, .gz, .zip and plain text patches. 201# If you do not specify any options, then epatch will default to the directory
115# Currently all patches should be the same format. 202# specified by EPATCH_SOURCE.
116# 203#
117# You do not have to specify '-p' option to patch, as it will 204# When processing directories, epatch will apply all patches that match:
118# try with -p0 to -p5 until it succeed, or fail at -p5. 205# @CODE
119# 206# if ${EPATCH_FORCE} != "yes"
120# Above EPATCH_* variables can be used to control various defaults,
121# bug they should be left as is to ensure an ebuild can rely on
122# them for.
123#
124# Patches are applied in current directory.
125#
126# Bulk Patches should preferibly have the form of:
127#
128# ??_${ARCH}_foo.${EPATCH_SUFFIX} 207# ??_${ARCH}_foo.${EPATCH_SUFFIX}
208# else
209# *.${EPATCH_SUFFIX}
210# @CODE
211# The leading ?? are typically numbers used to force consistent patch ordering.
212# The arch field is used to apply patches only for the host architecture with
213# the special value of "all" means apply for everyone. Note that using values
214# other than "all" is highly discouraged -- you should apply patches all the
215# time and let architecture details be detected at configure/compile time.
129# 216#
130# For example: 217# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
218# for patches to apply.
131# 219#
132# 01_all_misc-fix.patch.bz2 220# Refer to the other EPATCH_xxx variables for more customization of behavior.
133# 02_sparc_another-fix.patch.bz2
134#
135# This ensures that there are a set order, and you can have ARCH
136# specific patches.
137#
138# If you however give an argument to epatch(), it will treat it as a
139# single patch that need to be applied if its a file. If on the other
140# hand its a directory, it will set EPATCH_SOURCE to this.
141#
142# <azarah@gentoo.org> (10 Nov 2002)
143#
144epatch() { 221epatch() {
145 _epatch_draw_line() { 222 _epatch_draw_line() {
223 # create a line of same length as input string
146 [[ -z $1 ]] && set "$(printf "%65s" '')" 224 [[ -z $1 ]] && set "$(printf "%65s" '')"
147 echo "${1//?/=}" 225 echo "${1//?/=}"
148 } 226 }
149 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
150 local PIPE_CMD=""
151 local STDERR_TARGET="${T}/$$.out"
152 local PATCH_TARGET="${T}/$$.patch"
153 local PATCH_SUFFIX=""
154 local SINGLE_PATCH="no"
155 local x=""
156 227
157 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 228 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
158 229
159 if [ "$#" -gt 1 ] 230 # Let the rest of the code process one user arg at a time --
160 then 231 # each arg may expand into multiple patches, and each arg may
232 # need to start off with the default global EPATCH_xxx values
233 if [[ $# -gt 1 ]] ; then
161 local m="" 234 local m
162 for m in "$@" ; do 235 for m in "$@" ; do
163 epatch "${m}" 236 epatch "${m}"
164 done 237 done
165 return 0 238 return 0
166 fi 239 fi
167 240
168 if [ -n "$1" -a -f "$1" ] 241 local SINGLE_PATCH="no"
169 then 242 # no args means process ${EPATCH_SOURCE}
243 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
244
245 if [[ -f $1 ]] ; then
170 SINGLE_PATCH="yes" 246 SINGLE_PATCH="yes"
171 247 set -- "$1"
172 local EPATCH_SOURCE="$1" 248 # Use the suffix from the single patch (localize it); the code
249 # below will find the suffix for us
173 local EPATCH_SUFFIX="${1##*\.}" 250 local EPATCH_SUFFIX=$1
174 251
175 elif [ -n "$1" -a -d "$1" ] 252 elif [[ -d $1 ]] ; then
176 then 253 # Some people like to make dirs of patches w/out suffixes (vim)
177 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 254 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
178 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 255
256 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
257 # Re-use EPATCH_SOURCE as a search dir
258 epatch "${EPATCH_SOURCE}/$1"
259 return $?
260
261 else
262 # sanity check ... if it isn't a dir or file, wtf man ?
263 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
264 echo
265 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
266 eerror
267 eerror " ${EPATCH_SOURCE}"
268 eerror " ( ${EPATCH_SOURCE##*/} )"
269 echo
270 die "Cannot find \$EPATCH_SOURCE!"
271 fi
272
273 local PIPE_CMD
274 case ${EPATCH_SUFFIX##*\.} in
275 xz) PIPE_CMD="xz -dc" ;;
276 lzma) PIPE_CMD="lzma -dc" ;;
277 bz2) PIPE_CMD="bzip2 -dc" ;;
278 gz|Z|z) PIPE_CMD="gzip -dc" ;;
279 ZIP|zip) PIPE_CMD="unzip -p" ;;
280 *) ;;
281 esac
282
283 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
284
285 local x
286 for x in "$@" ; do
287 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
288 # didn't match anything, ignore continue on
289 [[ ! -f ${x} ]] && continue
290
291 local patchname=${x##*/}
292
293 # Apply single patches, or forced sets of patches, or
294 # patches with ARCH dependant names.
295 # ???_arch_foo.patch
296 # Else, skip this input altogether
297 local a=${patchname#*_} # strip the ???_
298 a=${a%%_*} # strip the _foo.patch
299 if ! [[ ${SINGLE_PATCH} == "yes" || \
300 ${EPATCH_FORCE} == "yes" || \
301 ${a} == all || \
302 ${a} == ${ARCH} ]]
179 then 303 then
180 local EPATCH_SOURCE="$1/*" 304 continue
305 fi
306
307 # Let people filter things dynamically
308 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
309 # let people use globs in the exclude
310 eshopts_push -o noglob
311
312 local ex
313 for ex in ${EPATCH_EXCLUDE} ; do
314 if [[ ${patchname} == ${ex} ]] ; then
315 eshopts_pop
316 continue 2
317 fi
318 done
319
320 eshopts_pop
321 fi
322
323 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
324 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
325 einfo "${EPATCH_SINGLE_MSG}"
326 else
327 einfo "Applying ${patchname} ..."
328 fi
181 else 329 else
182 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 330 einfo " ${patchname} ..."
183 fi 331 fi
184 else 332
185 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 333 # most of the time, there will only be one run per unique name,
186 then 334 # but if there are more, make sure we get unique log filenames
187 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 335 local STDERR_TARGET="${T}/${patchname}.out"
188 then 336 if [[ -e ${STDERR_TARGET} ]] ; then
189 EPATCH_SOURCE="$1" 337 STDERR_TARGET="${T}/${patchname}-$$.out"
338 fi
339
340 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
341
342 # Decompress the patch if need be
343 local count=0
344 local PATCH_TARGET
345 if [[ -n ${PIPE_CMD} ]] ; then
346 PATCH_TARGET="${T}/$$.patch"
347 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
348
349 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
350 echo
351 eerror "Could not extract patch!"
352 #die "Could not extract patch!"
353 count=5
354 break
190 fi 355 fi
356 else
357 PATCH_TARGET=${x}
358 fi
191 359
360 # Check for absolute paths in patches. If sandbox is disabled,
361 # people could (accidently) patch files in the root filesystem.
362 # Or trigger other unpleasantries #237667. So disallow -p0 on
363 # such patches.
364 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
365 if [[ -n ${abs_paths} ]] ; then
366 count=1
367 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
368 fi
369 # Similar reason, but with relative paths.
370 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
371 if [[ -n ${rel_paths} ]] ; then
372 eqawarn "QA Notice: Your patch uses relative paths '../'."
373 eqawarn " In the future this will cause a failure."
374 eqawarn "${rel_paths}"
375 fi
376
377 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
378 while [[ ${count} -lt 5 ]] ; do
379 # Generate some useful debug info ...
380 (
381 _epatch_draw_line "***** ${patchname} *****"
192 echo 382 echo
193 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 383 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
384 echo
385 _epatch_draw_line "***** ${patchname} *****"
386 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
387 ret=$?
388 echo
389 echo "patch program exited with status ${ret}"
390 exit ${ret}
391 ) >> "${STDERR_TARGET}"
392
393 if [ $? -eq 0 ] ; then
394 (
395 _epatch_draw_line "***** ${patchname} *****"
396 echo
397 echo "ACTUALLY APPLYING ${patchname} ..."
398 echo
399 _epatch_draw_line "***** ${patchname} *****"
400 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
401 ret=$?
402 echo
403 echo "patch program exited with status ${ret}"
404 exit ${ret}
405 ) >> "${STDERR_TARGET}"
406
407 if [ $? -ne 0 ] ; then
408 echo
409 eerror "A dry-run of patch command succeeded, but actually"
410 eerror "applying the patch failed!"
411 #die "Real world sux compared to the dreamworld!"
412 count=5
413 fi
414 break
415 fi
416
417 : $(( count++ ))
418 done
419
420 # if we had to decompress the patch, delete the temp one
421 if [[ -n ${PIPE_CMD} ]] ; then
422 rm -f "${PATCH_TARGET}"
423 fi
424
425 if [[ ${count} -ge 5 ]] ; then
426 echo
427 eerror "Failed Patch: ${patchname} !"
428 eerror " ( ${PATCH_TARGET} )"
194 eerror 429 eerror
195 eerror " ${EPATCH_SOURCE}" 430 eerror "Include in your bugreport the contents of:"
196 eerror " ( ${EPATCH_SOURCE##*/} )" 431 eerror
432 eerror " ${STDERR_TARGET}"
197 echo 433 echo
198 die "Cannot find \$EPATCH_SOURCE!"
199 fi
200
201 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
202 fi
203
204 case ${EPATCH_SUFFIX##*\.} in
205 bz2)
206 PIPE_CMD="bzip2 -dc"
207 PATCH_SUFFIX="bz2"
208 ;;
209 gz|Z|z)
210 PIPE_CMD="gzip -dc"
211 PATCH_SUFFIX="gz"
212 ;;
213 ZIP|zip)
214 PIPE_CMD="unzip -p"
215 PATCH_SUFFIX="zip"
216 ;;
217 *)
218 PIPE_CMD="cat"
219 PATCH_SUFFIX="patch"
220 ;;
221 esac
222
223 if [ "${SINGLE_PATCH}" = "no" ]
224 then
225 einfo "${EPATCH_MULTI_MSG}"
226 fi
227 for x in ${EPATCH_SOURCE}
228 do
229 # New ARCH dependant patch naming scheme ...
230 #
231 # ???_arch_foo.patch
232 #
233 if [ -f ${x} ] && \
234 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
235 [ "${EPATCH_FORCE}" = "yes" ])
236 then
237 local count=0
238 local popts="${EPATCH_OPTS}"
239 local patchname=${x##*/}
240
241 if [ -n "${EPATCH_EXCLUDE}" ]
242 then
243 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
244 then
245 continue
246 fi
247 fi
248
249 if [ "${SINGLE_PATCH}" = "yes" ]
250 then
251 if [ -n "${EPATCH_SINGLE_MSG}" ]
252 then
253 einfo "${EPATCH_SINGLE_MSG}"
254 else
255 einfo "Applying ${patchname} ..."
256 fi
257 else
258 einfo " ${patchname} ..."
259 fi
260
261 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
262 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
263
264 # Allow for prefix to differ ... im lazy, so shoot me :/
265 while [ "${count}" -lt 5 ]
266 do
267 # Generate some useful debug info ...
268 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
269 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
270
271 if [ "${PATCH_SUFFIX}" != "patch" ]
272 then
273 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
274 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
275 else
276 PATCH_TARGET="${x}"
277 fi
278
279 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
280 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
281
282 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
283 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
284
285 if [ "${PATCH_SUFFIX}" != "patch" ]
286 then
287 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
288 then
289 echo
290 eerror "Could not extract patch!"
291 #die "Could not extract patch!"
292 count=5
293 break
294 fi
295 fi
296
297 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
298 then
299 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
300 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
301 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
302 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
303 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
304
305 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
306 _epatch_assert
307
308 if [ "$?" -ne 0 ]
309 then
310 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
311 echo
312 eerror "A dry-run of patch command succeeded, but actually"
313 eerror "applying the patch failed!"
314 #die "Real world sux compared to the dreamworld!"
315 count=5
316 fi
317
318 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
319
320 break
321 fi
322
323 count=$((count + 1))
324 done
325
326 if [ "${PATCH_SUFFIX}" != "patch" ]
327 then
328 rm -f ${PATCH_TARGET}
329 fi
330
331 if [ "${count}" -eq 5 ]
332 then
333 echo
334 eerror "Failed Patch: ${patchname} !"
335 eerror " ( ${PATCH_TARGET} )"
336 eerror
337 eerror "Include in your bugreport the contents of:"
338 eerror
339 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
340 echo
341 die "Failed Patch: ${patchname}!" 434 die "Failed Patch: ${patchname}!"
342 fi 435 fi
343 436
344 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 437 # if everything worked, delete the patch log
345 438 rm -f "${STDERR_TARGET}"
346 eend 0 439 eend 0
347 fi
348 done 440 done
349 if [ "${SINGLE_PATCH}" = "no" ] 441
350 then 442 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
351 einfo "Done with patching" 443 : # everything worked
444}
445
446# @FUNCTION: epatch_user
447# @USAGE:
448# @DESCRIPTION:
449# Applies user-provided patches to the source tree. The patches are
450# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
451# of these three directories to exist will be the one to use, ignoring
452# any more general directories which might exist as well.
453#
454# User patches are intended for quick testing of patches without ebuild
455# modifications, as well as for permanent customizations a user might
456# desire. Obviously, there can be no official support for arbitrarily
457# patched ebuilds. So whenever a build log in a bug report mentions that
458# user patches were applied, the user should be asked to reproduce the
459# problem without these.
460#
461# Not all ebuilds do call this function, so placing patches in the
462# stated directory might or might not work, depending on the package and
463# the eclasses it inherits and uses. It is safe to call the function
464# repeatedly, so it is always possible to add a call at the ebuild
465# level. The first call is the time when the patches will be
466# applied.
467#
468# Ideally, this function should be called after gentoo-specific patches
469# have been applied, so that their code can be modified as well, but
470# before calls to e.g. eautoreconf, as the user patches might affect
471# autotool input files as well.
472epatch_user() {
473 [[ $# -ne 0 ]] && die "epatch_user takes no options"
474
475 # Allow multiple calls to this function; ignore all but the first
476 local applied="${T}/epatch_user.applied"
477 [[ -e ${applied} ]] && return 2
478
479 # don't clobber any EPATCH vars that the parent might want
480 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
481 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
482 EPATCH_SOURCE=${base}/${CTARGET}/${check}
483 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
484 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
485 if [[ -d ${EPATCH_SOURCE} ]] ; then
486 EPATCH_SOURCE=${EPATCH_SOURCE} \
487 EPATCH_SUFFIX="patch" \
488 EPATCH_FORCE="yes" \
489 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
490 epatch
491 echo "${EPATCH_SOURCE}" > "${applied}"
492 return 0
352 fi 493 fi
494 done
495 echo "none" > "${applied}"
496 return 1
353} 497}
354 498
499# @FUNCTION: emktemp
500# @USAGE: [temp dir]
501# @DESCRIPTION:
355# Cheap replacement for when debianutils (and thus mktemp) 502# Cheap replacement for when debianutils (and thus mktemp)
356# does not exist on the users system 503# does not exist on the users system.
357# vapier@gentoo.org
358#
359# Takes just 1 optional parameter (the directory to create tmpfile in)
360emktemp() { 504emktemp() {
361 local exe="touch" 505 local exe="touch"
362 [[ $1 == -d ]] && exe="mkdir" && shift 506 [[ $1 == -d ]] && exe="mkdir" && shift
363 local topdir=$1 507 local topdir=$1
364 508
366 [[ -z ${T} ]] \ 510 [[ -z ${T} ]] \
367 && topdir="/tmp" \ 511 && topdir="/tmp" \
368 || topdir=${T} 512 || topdir=${T}
369 fi 513 fi
370 514
371 if [[ -z $(type -p mktemp) ]] ; then 515 if ! type -P mktemp > /dev/null ; then
516 # system lacks `mktemp` so we have to fake it
372 local tmp=/ 517 local tmp=/
373 while [[ -e ${tmp} ]] ; do 518 while [[ -e ${tmp} ]] ; do
374 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 519 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
375 done 520 done
376 ${exe} "${tmp}" || ${exe} -p "${tmp}" 521 ${exe} "${tmp}" || ${exe} -p "${tmp}"
377 echo "${tmp}" 522 echo "${tmp}"
378 else 523 else
524 # the args here will give slightly wierd names on BSD,
525 # but should produce a usable file on all userlands
379 if [[ ${exe} == "touch" ]] ; then 526 if [[ ${exe} == "touch" ]] ; then
380 [[ ${USERLAND} == "GNU" ]] \
381 && mktemp -p "${topdir}" \
382 || TMPDIR="${topdir}" mktemp -t tmp 527 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
383 else 528 else
384 [[ ${USERLAND} == "GNU" ]] \
385 && mktemp -d "${topdir}" \
386 || TMPDIR="${topdir}" mktemp -dt tmp 529 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
387 fi
388 fi
389}
390
391# Small wrapper for getent (Linux), nidump (Mac OS X),
392# and pw (FreeBSD) used in enewuser()/enewgroup()
393# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
394# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
395#
396# egetent(database, key)
397egetent() {
398 case ${CHOST} in
399 *-darwin*)
400 case "$2" in
401 *[!0-9]*) # Non numeric
402 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
403 ;;
404 *) # Numeric
405 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
406 ;;
407 esac
408 ;;
409 *-freebsd*|*-dragonfly*)
410 local opts action="user"
411 [[ $1 == "passwd" ]] || action="group"
412
413 # lookup by uid/gid
414 if [[ $2 == [[:digit:]]* ]] ; then
415 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
416 fi
417
418 pw show ${action} ${opts} "$2" -q
419 ;;
420 *-netbsd*|*-openbsd*)
421 grep "$2:\*:" /etc/$1
422 ;;
423 *)
424 type -p nscd >& /dev/null && nscd -i "$1"
425 getent "$1" "$2"
426 ;;
427 esac
428}
429
430# Simplify/standardize adding users to the system
431# vapier@gentoo.org
432#
433# enewuser(username, uid, shell, homedir, groups, extra options)
434#
435# Default values if you do not specify any:
436# username: REQUIRED !
437# uid: next available (see useradd(8))
438# note: pass -1 to get default behavior
439# shell: /bin/false
440# homedir: /dev/null
441# groups: none
442# extra: comment of 'added by portage for ${PN}'
443enewuser() {
444 case ${EBUILD_PHASE} in
445 unpack|compile|test|install)
446 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
447 eerror "Package fails at QA and at life. Please file a bug."
448 die "Bad package! enewuser is only for use in pkg_* functions!"
449 esac
450
451 # get the username
452 local euser=$1; shift
453 if [[ -z ${euser} ]] ; then
454 eerror "No username specified !"
455 die "Cannot call enewuser without a username"
456 fi
457
458 # lets see if the username already exists
459 if [[ -n $(egetent passwd "${euser}") ]] ; then
460 return 0
461 fi
462 einfo "Adding user '${euser}' to your system ..."
463
464 # options to pass to useradd
465 local opts=
466
467 # handle uid
468 local euid=$1; shift
469 if [[ -n ${euid} && ${euid} != -1 ]] ; then
470 if [[ ${euid} -gt 0 ]] ; then
471 if [[ -n $(egetent passwd ${euid}) ]] ; then
472 euid="next"
473 fi 530 fi
474 else
475 eerror "Userid given but is not greater than 0 !"
476 die "${euid} is not a valid UID"
477 fi 531 fi
478 else
479 euid="next"
480 fi
481 if [[ ${euid} == "next" ]] ; then
482 for ((euid = 101; euid <= 999; euid++)); do
483 [[ -z $(egetent passwd ${euid}) ]] && break
484 done
485 fi
486 opts="${opts} -u ${euid}"
487 einfo " - Userid: ${euid}"
488
489 # handle shell
490 local eshell=$1; shift
491 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
492 if [[ ! -e ${ROOT}${eshell} ]] ; then
493 eerror "A shell was specified but it does not exist !"
494 die "${eshell} does not exist in ${ROOT}"
495 fi
496 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
497 eerror "Do not specify ${eshell} yourself, use -1"
498 die "Pass '-1' as the shell parameter"
499 fi
500 else
501 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
502 [[ -x ${ROOT}${shell} ]] && break
503 done
504
505 if [[ ${shell} == "/dev/null" ]] ; then
506 eerror "Unable to identify the shell to use, proceeding with userland default."
507 case ${USERLAND} in
508 GNU) shell="/bin/false" ;;
509 BSD) shell="/sbin/nologin" ;;
510 Darwin) shell="/usr/sbin/nologin" ;;
511 *) die "Unable to identify the default shell for userland ${USERLAND}"
512 esac
513 fi
514
515 eshell=${shell}
516 fi
517 einfo " - Shell: ${eshell}"
518 opts="${opts} -s ${eshell}"
519
520 # handle homedir
521 local ehome=$1; shift
522 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
523 ehome="/dev/null"
524 fi
525 einfo " - Home: ${ehome}"
526 opts="${opts} -d ${ehome}"
527
528 # handle groups
529 local egroups=$1; shift
530 if [[ ! -z ${egroups} ]] ; then
531 local oldifs=${IFS}
532 local defgroup="" exgroups=""
533
534 export IFS=","
535 for g in ${egroups} ; do
536 export IFS=${oldifs}
537 if [[ -z $(egetent group "${g}") ]] ; then
538 eerror "You must add group ${g} to the system first"
539 die "${g} is not a valid GID"
540 fi
541 if [[ -z ${defgroup} ]] ; then
542 defgroup=${g}
543 else
544 exgroups="${exgroups},${g}"
545 fi
546 export IFS=","
547 done
548 export IFS=${oldifs}
549
550 opts="${opts} -g ${defgroup}"
551 if [[ ! -z ${exgroups} ]] ; then
552 opts="${opts} -G ${exgroups:1}"
553 fi
554 else
555 egroups="(none)"
556 fi
557 einfo " - Groups: ${egroups}"
558
559 # handle extra and add the user
560 local oldsandbox=${SANDBOX_ON}
561 export SANDBOX_ON="0"
562 case ${CHOST} in
563 *-darwin*)
564 ### Make the user
565 if [[ -z $@ ]] ; then
566 dscl . create /users/${euser} uid ${euid}
567 dscl . create /users/${euser} shell ${eshell}
568 dscl . create /users/${euser} home ${ehome}
569 dscl . create /users/${euser} realname "added by portage for ${PN}"
570 ### Add the user to the groups specified
571 local oldifs=${IFS}
572 export IFS=","
573 for g in ${egroups} ; do
574 dscl . merge /groups/${g} users ${euser}
575 done
576 export IFS=${oldifs}
577 else
578 einfo "Extra options are not supported on Darwin yet"
579 einfo "Please report the ebuild along with the info below"
580 einfo "eextra: $@"
581 die "Required function missing"
582 fi
583 ;;
584 *-freebsd*|*-dragonfly*)
585 if [[ -z $@ ]] ; then
586 pw useradd ${euser} ${opts} \
587 -c "added by portage for ${PN}" \
588 die "enewuser failed"
589 else
590 einfo " - Extra: $@"
591 pw useradd ${euser} ${opts} \
592 "$@" || die "enewuser failed"
593 fi
594 ;;
595
596 *-netbsd*)
597 if [[ -z $@ ]] ; then
598 useradd ${opts} ${euser} || die "enewuser failed"
599 else
600 einfo " - Extra: $@"
601 useradd ${opts} ${euser} "$@" || die "enewuser failed"
602 fi
603 ;;
604
605 *-openbsd*)
606 if [[ -z $@ ]] ; then
607 useradd -u ${euid} -s ${eshell} \
608 -d ${ehome} -c "Added by portage for ${PN}" \
609 -g ${egroups} ${euser} || die "enewuser failed"
610 else
611 einfo " - Extra: $@"
612 useradd -u ${euid} -s ${eshell} \
613 -d ${ehome} -c "Added by portage for ${PN}" \
614 -g ${egroups} ${euser} "$@" || die "enewuser failed"
615 fi
616 ;;
617
618 *)
619 if [[ -z $@ ]] ; then
620 useradd ${opts} ${euser} \
621 -c "added by portage for ${PN}" \
622 || die "enewuser failed"
623 else
624 einfo " - Extra: $@"
625 useradd ${opts} ${euser} "$@" \
626 || die "enewuser failed"
627 fi
628 ;;
629 esac
630
631 if [[ ! -e ${ROOT}/${ehome} ]] ; then
632 einfo " - Creating ${ehome} in ${ROOT}"
633 mkdir -p "${ROOT}/${ehome}"
634 chown ${euser} "${ROOT}/${ehome}"
635 chmod 755 "${ROOT}/${ehome}"
636 fi
637
638 export SANDBOX_ON=${oldsandbox}
639} 532}
640 533
641# Simplify/standardize adding groups to the system 534# @FUNCTION: edos2unix
642# vapier@gentoo.org 535# @USAGE: <file> [more files ...]
643# 536# @DESCRIPTION:
644# enewgroup(group, gid) 537# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
645# 538# to remove all of these text utilities from DEPEND variables because this
646# Default values if you do not specify any: 539# is a script based solution. Just give it a list of files to convert and
647# groupname: REQUIRED ! 540# they will all be changed from the DOS CRLF format to the UNIX LF format.
648# gid: next available (see groupadd(8))
649# extra: none
650enewgroup() {
651 case ${EBUILD_PHASE} in
652 unpack|compile|test|install)
653 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
654 eerror "Package fails at QA and at life. Please file a bug."
655 die "Bad package! enewgroup is only for use in pkg_* functions!"
656 esac
657
658 # get the group
659 local egroup="$1"; shift
660 if [ -z "${egroup}" ]
661 then
662 eerror "No group specified !"
663 die "Cannot call enewgroup without a group"
664 fi
665
666 # see if group already exists
667 if [[ -n $(egetent group "${egroup}") ]]; then
668 return 0
669 fi
670 einfo "Adding group '${egroup}' to your system ..."
671
672 # options to pass to useradd
673 local opts=
674
675 # handle gid
676 local egid="$1"; shift
677 if [ ! -z "${egid}" ]
678 then
679 if [ "${egid}" -gt 0 ]
680 then
681 if [ -z "`egetent group ${egid}`" ]
682 then
683 if [[ "${CHOST}" == *-darwin* ]]; then
684 opts="${opts} ${egid}"
685 else
686 opts="${opts} -g ${egid}"
687 fi
688 else
689 egid="next available; requested gid taken"
690 fi
691 else
692 eerror "Groupid given but is not greater than 0 !"
693 die "${egid} is not a valid GID"
694 fi
695 else
696 egid="next available"
697 fi
698 einfo " - Groupid: ${egid}"
699
700 # handle extra
701 local eextra="$@"
702 opts="${opts} ${eextra}"
703
704 # add the group
705 local oldsandbox="${SANDBOX_ON}"
706 export SANDBOX_ON="0"
707 case ${CHOST} in
708 *-darwin*)
709 if [ ! -z "${eextra}" ];
710 then
711 einfo "Extra options are not supported on Darwin/OS X yet"
712 einfo "Please report the ebuild along with the info below"
713 einfo "eextra: ${eextra}"
714 die "Required function missing"
715 fi
716
717 # If we need the next available
718 case ${egid} in
719 *[!0-9]*) # Non numeric
720 for ((egid = 101; egid <= 999; egid++)); do
721 [[ -z $(egetent group ${egid}) ]] && break
722 done
723 esac
724 dscl . create /groups/${egroup} gid ${egid}
725 dscl . create /groups/${egroup} passwd '*'
726 ;;
727
728 *-freebsd*|*-dragonfly*)
729 case ${egid} in
730 *[!0-9]*) # Non numeric
731 for ((egid = 101; egid <= 999; egid++)); do
732 [[ -z $(egetent group ${egid}) ]] && break
733 done
734 esac
735 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
736 ;;
737
738 *-netbsd*)
739 case ${egid} in
740 *[!0-9]*) # Non numeric
741 for ((egid = 101; egid <= 999; egid++)); do
742 [[ -z $(egetent group ${egid}) ]] && break
743 done
744 esac
745 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
746 ;;
747
748 *)
749 groupadd ${opts} ${egroup} || die "enewgroup failed"
750 ;;
751 esac
752 export SANDBOX_ON="${oldsandbox}"
753}
754
755# Simple script to replace 'dos2unix' binaries
756# vapier@gentoo.org
757#
758# edos2unix(file, <more files> ...)
759edos2unix() { 541edos2unix() {
760 echo "$@" | xargs sed -i 's/\r$//' 542 [[ $# -eq 0 ]] && return 0
543 sed -i 's/\r$//' -- "$@" || die
761} 544}
762
763
764##############################################################
765# START: Handle .desktop files and menu entries #
766# maybe this should be separated into a new eclass some time #
767# lanius@gentoo.org #
768##############################################################
769 545
770# Make a desktop file ! 546# Make a desktop file !
771# Great for making those icons in kde/gnome startmenu ! 547# Great for making those icons in kde/gnome startmenu !
772# Amaze your friends ! Get the women ! Join today ! 548# Amaze your friends ! Get the women ! Join today !
773# 549#
774# make_desktop_entry(<command>, [name], [icon], [type], [path]) 550# make_desktop_entry(<command>, [name], [icon], [type], [fields])
775# 551#
776# binary: what command does the app run with ? 552# binary: what command does the app run with ?
777# name: the name that will show up in the menu 553# name: the name that will show up in the menu
778# icon: give your little like a pretty little icon ... 554# icon: give your little like a pretty little icon ...
779# this can be relative (to /usr/share/pixmaps) or 555# this can be relative (to /usr/share/pixmaps) or
780# a full path to an icon 556# a full path to an icon
781# type: what kind of application is this ? for categories: 557# type: what kind of application is this ? for categories:
782# http://www.freedesktop.org/Standards/desktop-entry-spec 558# http://standards.freedesktop.org/menu-spec/latest/apa.html
783# path: if your app needs to startup in a specific dir 559# fields: extra fields to append to the desktop file; a printf string
784make_desktop_entry() { 560make_desktop_entry() {
785 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 561 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
786 562
787 local exec=${1} 563 local exec=${1}
788 local name=${2:-${PN}} 564 local name=${2:-${PN}}
789 local icon=${3:-${PN}.png} 565 local icon=${3:-${PN}}
790 local type=${4} 566 local type=${4}
791 local path=${5} 567 local fields=${5}
792 568
793 if [[ -z ${type} ]] ; then 569 if [[ -z ${type} ]] ; then
794 local catmaj=${CATEGORY%%-*} 570 local catmaj=${CATEGORY%%-*}
795 local catmin=${CATEGORY##*-} 571 local catmin=${CATEGORY##*-}
796 case ${catmaj} in 572 case ${catmaj} in
797 app) 573 app)
798 case ${catmin} in 574 case ${catmin} in
575 accessibility) type=Accessibility;;
799 admin) type=System;; 576 admin) type=System;;
577 antivirus) type=System;;
578 arch) type=Archiving;;
579 backup) type=Archiving;;
800 cdr) type=DiscBurning;; 580 cdr) type=DiscBurning;;
801 dicts) type=Dictionary;; 581 dicts) type=Dictionary;;
582 doc) type=Documentation;;
802 editors) type=TextEditor;; 583 editors) type=TextEditor;;
803 emacs) type=TextEditor;; 584 emacs) type=TextEditor;;
804 emulation) type=Emulator;; 585 emulation) type=Emulator;;
805 laptop) type=HardwareSettings;; 586 laptop) type=HardwareSettings;;
806 office) type=Office;; 587 office) type=Office;;
588 pda) type=PDA;;
807 vim) type=TextEditor;; 589 vim) type=TextEditor;;
808 xemacs) type=TextEditor;; 590 xemacs) type=TextEditor;;
809 *) type=;;
810 esac 591 esac
811 ;; 592 ;;
812 593
813 dev) 594 dev)
814 type="Development" 595 type="Development"
815 ;; 596 ;;
816 597
817 games) 598 games)
818 case ${catmin} in 599 case ${catmin} in
819 action|fps) type=ActionGame;; 600 action|fps) type=ActionGame;;
820 arcade) type=ArcadeGame;; 601 arcade) type=ArcadeGame;;
821 board) type=BoardGame;; 602 board) type=BoardGame;;
822 kids) type=KidsGame;;
823 emulation) type=Emulator;; 603 emulation) type=Emulator;;
604 kids) type=KidsGame;;
824 puzzle) type=LogicGame;; 605 puzzle) type=LogicGame;;
825 rpg) type=RolePlaying;;
826 roguelike) type=RolePlaying;; 606 roguelike) type=RolePlaying;;
607 rpg) type=RolePlaying;;
827 simulation) type=Simulation;; 608 simulation) type=Simulation;;
828 sports) type=SportsGame;; 609 sports) type=SportsGame;;
829 strategy) type=StrategyGame;; 610 strategy) type=StrategyGame;;
830 *) type=;;
831 esac 611 esac
832 type="Game;${type}" 612 type="Game;${type}"
833 ;; 613 ;;
834 614
615 gnome)
616 type="Gnome;GTK"
617 ;;
618
619 kde)
620 type="KDE;Qt"
621 ;;
622
835 mail) 623 mail)
836 type="Network;Email" 624 type="Network;Email"
837 ;; 625 ;;
838 626
839 media) 627 media)
840 case ${catmin} in 628 case ${catmin} in
629 gfx)
841 gfx) type=Graphics;; 630 type=Graphics
631 ;;
632 *)
633 case ${catmin} in
842 radio) type=Tuner;; 634 radio) type=Tuner;;
843 sound) type=Audio;; 635 sound) type=Audio;;
844 tv) type=TV;; 636 tv) type=TV;;
845 video) type=Video;; 637 video) type=Video;;
846 *) type=;; 638 esac
639 type="AudioVideo;${type}"
640 ;;
847 esac 641 esac
848 type="AudioVideo;${type}"
849 ;; 642 ;;
850 643
851 net) 644 net)
852 case ${catmin} in 645 case ${catmin} in
853 dialup) type=Dialup;; 646 dialup) type=Dialup;;
854 ftp) type=FileTransfer;; 647 ftp) type=FileTransfer;;
855 im) type=InstantMessaging;; 648 im) type=InstantMessaging;;
856 irc) type=IRCClient;; 649 irc) type=IRCClient;;
857 mail) type=Email;; 650 mail) type=Email;;
858 news) type=News;; 651 news) type=News;;
859 nntp) type=News;; 652 nntp) type=News;;
860 p2p) type=FileTransfer;; 653 p2p) type=FileTransfer;;
861 *) type=;; 654 voip) type=Telephony;;
862 esac 655 esac
863 type="Network;${type}" 656 type="Network;${type}"
864 ;; 657 ;;
865 658
866 sci) 659 sci)
867 case ${catmin} in 660 case ${catmin} in
868 astro*) type=Astronomy;; 661 astro*) type=Astronomy;;
869 bio*) type=Biology;; 662 bio*) type=Biology;;
870 calc*) type=Calculator;; 663 calc*) type=Calculator;;
871 chem*) type=Chemistry;; 664 chem*) type=Chemistry;;
665 elec*) type=Electronics;;
872 geo*) type=Geology;; 666 geo*) type=Geology;;
873 math*) type=Math;; 667 math*) type=Math;;
874 *) type=;; 668 physics) type=Physics;;
669 visual*) type=DataVisualization;;
875 esac 670 esac
876 type="Science;${type}" 671 type="Education;Science;${type}"
672 ;;
673
674 sys)
675 type="System"
877 ;; 676 ;;
878 677
879 www) 678 www)
880 case ${catmin} in 679 case ${catmin} in
881 client) type=WebBrowser;; 680 client) type=WebBrowser;;
882 *) type=;;
883 esac 681 esac
884 type="Network" 682 type="Network;${type}"
885 ;; 683 ;;
886 684
887 *) 685 *)
888 type= 686 type=
889 ;; 687 ;;
895 local desktop_name="${PN}-${SLOT}" 693 local desktop_name="${PN}-${SLOT}"
896 fi 694 fi
897 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 695 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
898 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 696 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
899 697
698 # Don't append another ";" when a valid category value is provided.
699 type=${type%;}${type:+;}
700
701 eshopts_push -s extglob
702 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
703 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
704 ewarn "allowed in .desktop files if the value is not an absolute path."
705 icon=${icon%.@(xpm|png|svg)}
706 fi
707 eshopts_pop
708
900 cat <<-EOF > "${desktop}" 709 cat <<-EOF > "${desktop}"
901 [Desktop Entry] 710 [Desktop Entry]
902 Encoding=UTF-8
903 Version=0.9.2
904 Name=${name} 711 Name=${name}
905 Type=Application 712 Type=Application
906 Comment=${DESCRIPTION} 713 Comment=${DESCRIPTION}
907 Exec=${exec} 714 Exec=${exec}
908 TryExec=${exec%% *} 715 TryExec=${exec%% *}
909 Path=${path}
910 Icon=${icon} 716 Icon=${icon}
911 Categories=Application;${type}; 717 Categories=${type}
912 EOF 718 EOF
719
720 if [[ ${fields:-=} != *=* ]] ; then
721 # 5th arg used to be value to Path=
722 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
723 fields="Path=${fields}"
724 fi
725 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
913 726
914 ( 727 (
915 # wrap the env here so that the 'insinto' call 728 # wrap the env here so that the 'insinto' call
916 # doesn't corrupt the env of the caller 729 # doesn't corrupt the env of the caller
917 insinto /usr/share/applications 730 insinto /usr/share/applications
918 doins "${desktop}" 731 doins "${desktop}"
919 ) 732 ) || die "installing desktop file failed"
920} 733}
921 734
922 735# @FUNCTION: validate_desktop_entries
736# @USAGE: [directories]
737# @MAINTAINER:
738# Carsten Lohrke <carlo@gentoo.org>
739# @DESCRIPTION:
923# Validate desktop entries using desktop-file-utils 740# Validate desktop entries using desktop-file-utils
924# Carsten Lohrke <carlo@gentoo.org>
925#
926# Usage: validate_desktop_entries [directory ...]
927
928validate_desktop_entries() { 741validate_desktop_entries() {
929 if [[ -x /usr/bin/desktop-file-validate ]] ; then 742 if [[ -x /usr/bin/desktop-file-validate ]] ; then
930 einfo "Checking desktop entry validity" 743 einfo "Checking desktop entry validity"
931 local directories="" 744 local directories=""
932 for d in /usr/share/applications $@ ; do 745 for d in /usr/share/applications $@ ; do
945 else 758 else
946 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo." 759 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
947 fi 760 fi
948} 761}
949 762
950 763# @FUNCTION: make_session_desktop
951# Make a GDM/KDM Session file 764# @USAGE: <title> <command> [command args...]
765# @DESCRIPTION:
766# Make a GDM/KDM Session file. The title is the file to execute to start the
767# Window Manager. The command is the name of the Window Manager.
952# 768#
953# make_session_desktop(<title>, <command>) 769# You can set the name of the file via the ${wm} variable.
954# title: File to execute to start the Window Manager
955# command: Name of the Window Manager
956
957make_session_desktop() { 770make_session_desktop() {
958 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 771 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
959 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 772 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
960 773
961 local title=$1 774 local title=$1
962 local command=$2 775 local command=$2
963 local desktop=${T}/${wm}.desktop 776 local desktop=${T}/${wm:-${PN}}.desktop
777 shift 2
964 778
965 cat <<-EOF > "${desktop}" 779 cat <<-EOF > "${desktop}"
966 [Desktop Entry] 780 [Desktop Entry]
967 Encoding=UTF-8
968 Name=${title} 781 Name=${title}
969 Comment=This session logs you into ${title} 782 Comment=This session logs you into ${title}
970 Exec=${command} 783 Exec=${command} $*
971 TryExec=${command} 784 TryExec=${command}
972 Type=Application 785 Type=XSession
973 EOF 786 EOF
974 787
975 ( 788 (
976 # wrap the env here so that the 'insinto' call 789 # wrap the env here so that the 'insinto' call
977 # doesn't corrupt the env of the caller 790 # doesn't corrupt the env of the caller
978 insinto /usr/share/xsessions 791 insinto /usr/share/xsessions
979 doins "${desktop}" 792 doins "${desktop}"
980 ) 793 )
981} 794}
982 795
796# @FUNCTION: domenu
797# @USAGE: <menus>
798# @DESCRIPTION:
799# Install the list of .desktop menu files into the appropriate directory
800# (/usr/share/applications).
983domenu() { 801domenu() {
984 ( 802 (
985 # wrap the env here so that the 'insinto' call 803 # wrap the env here so that the 'insinto' call
986 # doesn't corrupt the env of the caller 804 # doesn't corrupt the env of the caller
987 local i j ret=0 805 local i j ret=0
993 elif [[ -d ${i} ]] ; then 811 elif [[ -d ${i} ]] ; then
994 for j in "${i}"/*.desktop ; do 812 for j in "${i}"/*.desktop ; do
995 doins "${j}" 813 doins "${j}"
996 ((ret+=$?)) 814 ((ret+=$?))
997 done 815 done
816 else
817 ((++ret))
998 fi 818 fi
999 done 819 done
1000 exit ${ret} 820 exit ${ret}
1001 ) 821 )
1002} 822}
823
824# @FUNCTION: newmenu
825# @USAGE: <menu> <newname>
826# @DESCRIPTION:
827# Like all other new* functions, install the specified menu as newname.
1003newmenu() { 828newmenu() {
1004 ( 829 (
1005 # wrap the env here so that the 'insinto' call 830 # wrap the env here so that the 'insinto' call
1006 # doesn't corrupt the env of the caller 831 # doesn't corrupt the env of the caller
1007 insinto /usr/share/applications 832 insinto /usr/share/applications
1008 newins "$@" 833 newins "$@"
1009 ) 834 )
1010} 835}
1011 836
837# @FUNCTION: doicon
838# @USAGE: <list of icons>
839# @DESCRIPTION:
840# Install the list of icons into the icon directory (/usr/share/pixmaps).
841# This is useful in conjunction with creating desktop/menu files.
1012doicon() { 842doicon() {
1013 ( 843 (
1014 # wrap the env here so that the 'insinto' call 844 # wrap the env here so that the 'insinto' call
1015 # doesn't corrupt the env of the caller 845 # doesn't corrupt the env of the caller
1016 local i j ret 846 local i j ret
1022 elif [[ -d ${i} ]] ; then 852 elif [[ -d ${i} ]] ; then
1023 for j in "${i}"/*.png ; do 853 for j in "${i}"/*.png ; do
1024 doins "${j}" 854 doins "${j}"
1025 ((ret+=$?)) 855 ((ret+=$?))
1026 done 856 done
857 else
858 ((++ret))
1027 fi 859 fi
1028 done 860 done
1029 exit ${ret} 861 exit ${ret}
1030 ) 862 )
1031} 863}
864
865# @FUNCTION: newicon
866# @USAGE: <icon> <newname>
867# @DESCRIPTION:
868# Like all other new* functions, install the specified icon as newname.
1032newicon() { 869newicon() {
1033 ( 870 (
1034 # wrap the env here so that the 'insinto' call 871 # wrap the env here so that the 'insinto' call
1035 # doesn't corrupt the env of the caller 872 # doesn't corrupt the env of the caller
1036 insinto /usr/share/pixmaps 873 insinto /usr/share/pixmaps
1037 newins "$@" 874 newins "$@"
1038 ) 875 )
1039} 876}
1040
1041##############################################################
1042# END: Handle .desktop files and menu entries #
1043##############################################################
1044
1045 877
1046# for internal use only (unpack_pdv and unpack_makeself) 878# for internal use only (unpack_pdv and unpack_makeself)
1047find_unpackable_file() { 879find_unpackable_file() {
1048 local src=$1 880 local src=$1
1049 if [[ -z ${src} ]] ; then 881 if [[ -z ${src} ]] ; then
1059 fi 891 fi
1060 [[ ! -e ${src} ]] && return 1 892 [[ ! -e ${src} ]] && return 1
1061 echo "${src}" 893 echo "${src}"
1062} 894}
1063 895
896# @FUNCTION: unpack_pdv
897# @USAGE: <file to unpack> <size of off_t>
898# @DESCRIPTION:
1064# Unpack those pesky pdv generated files ... 899# Unpack those pesky pdv generated files ...
1065# They're self-unpacking programs with the binary package stuffed in 900# They're self-unpacking programs with the binary package stuffed in
1066# the middle of the archive. Valve seems to use it a lot ... too bad 901# the middle of the archive. Valve seems to use it a lot ... too bad
1067# it seems to like to segfault a lot :(. So lets take it apart ourselves. 902# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1068# 903#
1069# Usage: unpack_pdv [file to unpack] [size of off_t]
1070# - you have to specify the off_t size ... i have no idea how to extract that 904# You have to specify the off_t size ... I have no idea how to extract that
1071# information out of the binary executable myself. basically you pass in 905# information out of the binary executable myself. Basically you pass in
1072# the size of the off_t type (in bytes) on the machine that built the pdv 906# the size of the off_t type (in bytes) on the machine that built the pdv
907# archive.
908#
1073# archive. one way to determine this is by running the following commands: 909# One way to determine this is by running the following commands:
910#
911# @CODE
1074# strings <pdv archive> | grep lseek 912# strings <pdv archive> | grep lseek
1075# strace -elseek <pdv archive> 913# strace -elseek <pdv archive>
914# @CODE
915#
1076# basically look for the first lseek command (we do the strings/grep because 916# Basically look for the first lseek command (we do the strings/grep because
1077# sometimes the function call is _llseek or something) and steal the 2nd 917# sometimes the function call is _llseek or something) and steal the 2nd
1078# parameter. here is an example: 918# parameter. Here is an example:
919#
920# @CODE
1079# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek 921# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1080# lseek 922# lseek
1081# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin 923# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1082# lseek(3, -4, SEEK_END) = 2981250 924# lseek(3, -4, SEEK_END) = 2981250
925# @CODE
926#
1083# thus we would pass in the value of '4' as the second parameter. 927# Thus we would pass in the value of '4' as the second parameter.
1084unpack_pdv() { 928unpack_pdv() {
1085 local src=$(find_unpackable_file "$1") 929 local src=$(find_unpackable_file "$1")
1086 local sizeoff_t=$2 930 local sizeoff_t=$2
1087 931
1088 [[ -z ${src} ]] && die "Could not locate source for '$1'" 932 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1150 true 994 true
1151 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 995 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1152 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 996 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1153} 997}
1154 998
999# @FUNCTION: unpack_makeself
1000# @USAGE: [file to unpack] [offset] [tail|dd]
1001# @DESCRIPTION:
1155# Unpack those pesky makeself generated files ... 1002# Unpack those pesky makeself generated files ...
1156# They're shell scripts with the binary package tagged onto 1003# They're shell scripts with the binary package tagged onto
1157# the end of the archive. Loki utilized the format as does 1004# the end of the archive. Loki utilized the format as does
1158# many other game companies. 1005# many other game companies.
1159# 1006#
1160# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1007# If the file is not specified, then ${A} is used. If the
1161# - If the file is not specified then unpack will utilize ${A}.
1162# - If the offset is not specified then we will attempt to extract 1008# offset is not specified then we will attempt to extract
1163# the proper offset from the script itself. 1009# the proper offset from the script itself.
1164unpack_makeself() { 1010unpack_makeself() {
1165 local src_input=${1:-${A}} 1011 local src_input=${1:-${A}}
1166 local src=$(find_unpackable_file "${src_input}") 1012 local src=$(find_unpackable_file "${src_input}")
1167 local skip=$2 1013 local skip=$2
1168 local exe=$3 1014 local exe=$3
1170 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1016 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1171 1017
1172 local shrtsrc=$(basename "${src}") 1018 local shrtsrc=$(basename "${src}")
1173 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1019 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1174 if [[ -z ${skip} ]] ; then 1020 if [[ -z ${skip} ]] ; then
1175 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1021 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1176 local skip=0 1022 local skip=0
1177 exe=tail 1023 exe=tail
1178 case ${ver} in 1024 case ${ver} in
1179 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1025 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1180 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1026 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1182 2.0|2.0.1) 1028 2.0|2.0.1)
1183 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1029 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1184 ;; 1030 ;;
1185 2.1.1) 1031 2.1.1)
1186 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1032 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1187 let skip="skip + 1" 1033 (( skip++ ))
1188 ;; 1034 ;;
1189 2.1.2) 1035 2.1.2)
1190 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1036 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1191 let skip="skip + 1" 1037 (( skip++ ))
1192 ;; 1038 ;;
1193 2.1.3) 1039 2.1.3)
1194 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1040 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1195 let skip="skip + 1" 1041 (( skip++ ))
1196 ;; 1042 ;;
1197 2.1.4|2.1.5) 1043 2.1.4|2.1.5)
1198 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1044 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1199 skip=$(head -n ${skip} "${src}" | wc -c) 1045 skip=$(head -n ${skip} "${src}" | wc -c)
1200 exe="dd" 1046 exe="dd"
1209 esac 1055 esac
1210 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1056 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1211 fi 1057 fi
1212 case ${exe} in 1058 case ${exe} in
1213 tail) exe="tail -n +${skip} '${src}'";; 1059 tail) exe="tail -n +${skip} '${src}'";;
1214 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1060 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1215 *) die "makeself cant handle exe '${exe}'" 1061 *) die "makeself cant handle exe '${exe}'"
1216 esac 1062 esac
1217 1063
1218 # lets grab the first few bytes of the file to figure out what kind of archive it is 1064 # lets grab the first few bytes of the file to figure out what kind of archive it is
1219 local tmpfile=$(emktemp) 1065 local filetype tmpfile=$(emktemp)
1220 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1066 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1221 local filetype=$(file -b "${tmpfile}") 1067 filetype=$(file -b "${tmpfile}") || die
1222 case ${filetype} in 1068 case ${filetype} in
1223 *tar\ archive*) 1069 *tar\ archive*)
1224 eval ${exe} | tar --no-same-owner -xf - 1070 eval ${exe} | tar --no-same-owner -xf -
1225 ;; 1071 ;;
1226 bzip2*) 1072 bzip2*)
1238 ;; 1084 ;;
1239 esac 1085 esac
1240 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})" 1086 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1241} 1087}
1242 1088
1089# @FUNCTION: check_license
1090# @USAGE: [license]
1091# @DESCRIPTION:
1243# Display a license for user to accept. 1092# Display a license for user to accept. If no license is
1244#
1245# Usage: check_license [license]
1246# - If the file is not specified then ${LICENSE} is used. 1093# specified, then ${LICENSE} is used.
1247check_license() { 1094check_license() {
1248 local lic=$1 1095 local lic=$1
1249 if [ -z "${lic}" ] ; then 1096 if [ -z "${lic}" ] ; then
1250 lic="${PORTDIR}/licenses/${LICENSE}" 1097 lic="${PORTDIR}/licenses/${LICENSE}"
1251 else 1098 else
1255 lic="${PWD}/${lic}" 1102 lic="${PWD}/${lic}"
1256 elif [ -e "${lic}" ] ; then 1103 elif [ -e "${lic}" ] ; then
1257 lic="${lic}" 1104 lic="${lic}"
1258 fi 1105 fi
1259 fi 1106 fi
1260 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1261 local l="`basename ${lic}`" 1107 local l="`basename ${lic}`"
1262 1108
1263 # here is where we check for the licenses the user already 1109 # here is where we check for the licenses the user already
1264 # accepted ... if we don't find a match, we make the user accept 1110 # accepted ... if we don't find a match, we make the user accept
1265 local shopts=$-
1266 local alic 1111 local alic
1267 set -o noglob #so that bash doesn't expand "*" 1112 eshopts_push -o noglob # so that bash doesn't expand "*"
1268 for alic in ${ACCEPT_LICENSE} ; do 1113 for alic in ${ACCEPT_LICENSE} ; do
1269 if [[ ${alic} == ${l} ]]; then 1114 if [[ ${alic} == ${l} ]]; then
1270 set +o noglob; set -${shopts} #reset old shell opts 1115 eshopts_pop
1271 return 0 1116 return 0
1272 fi 1117 fi
1273 done 1118 done
1274 set +o noglob; set -$shopts #reset old shell opts 1119 eshopts_pop
1120 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1275 1121
1276 local licmsg=$(emktemp) 1122 local licmsg=$(emktemp)
1277 cat <<-EOF > ${licmsg} 1123 cat <<-EOF > ${licmsg}
1278 ********************************************************** 1124 **********************************************************
1279 The following license outlines the terms of use of this 1125 The following license outlines the terms of use of this
1280 package. You MUST accept this license for installation to 1126 package. You MUST accept this license for installation to
1281 continue. When you are done viewing, hit 'q'. If you 1127 continue. When you are done viewing, hit 'q'. If you
1282 CTRL+C out of this, the install will not run! 1128 CTRL+C out of this, the install will not run!
1283 ********************************************************** 1129 **********************************************************
1284 1130
1285 EOF 1131 EOF
1286 cat ${lic} >> ${licmsg} 1132 cat ${lic} >> ${licmsg}
1287 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}" 1133 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1288 einfon "Do you accept the terms of this license (${l})? [yes/no] " 1134 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1289 read alic 1135 read alic
1297 die "Failed to accept license" 1143 die "Failed to accept license"
1298 ;; 1144 ;;
1299 esac 1145 esac
1300} 1146}
1301 1147
1148# @FUNCTION: cdrom_get_cds
1149# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1150# @DESCRIPTION:
1302# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates 1151# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1303# the whole 'non-interactive' policy, but damnit I want CD support ! 1152# the whole 'non-interactive' policy, but damnit I want CD support !
1304# 1153#
1305# with these cdrom functions we handle all the user interaction and 1154# With these cdrom functions we handle all the user interaction and
1306# standardize everything. all you have to do is call cdrom_get_cds() 1155# standardize everything. All you have to do is call cdrom_get_cds()
1307# and when the function returns, you can assume that the cd has been 1156# and when the function returns, you can assume that the cd has been
1308# found at CDROM_ROOT. 1157# found at CDROM_ROOT.
1309# 1158#
1159# The function will attempt to locate a cd based upon a file that is on
1160# the cd. The more files you give this function, the more cds
1161# the cdrom functions will handle.
1162#
1310# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2', 1163# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1311# etc... if you want to give the cds better names, then just export 1164# etc... If you want to give the cds better names, then just export
1312# the appropriate CDROM_NAME variable before calling cdrom_get_cds(). 1165# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1313# - CDROM_NAME="fooie cd" - for when you only want 1 cd 1166# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1314# - CDROM_NAME_1="install cd" - for when you want more than 1 cd 1167# also use the CDROM_NAME_SET bash array.
1315# CDROM_NAME_2="data cd"
1316# - CDROM_NAME_SET=( "install cd" "data cd" ) - short hand for CDROM_NAME_#
1317# 1168#
1318# for those multi cd ebuilds, see the cdrom_load_next_cd() below. 1169# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1319#
1320# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1321# - this will attempt to locate a cd based upon a file that is on
1322# the cd ... the more files you give this function, the more cds
1323# the cdrom functions will handle
1324cdrom_get_cds() { 1170cdrom_get_cds() {
1325 # first we figure out how many cds we're dealing with by 1171 # first we figure out how many cds we're dealing with by
1326 # the # of files they gave us 1172 # the # of files they gave us
1327 local cdcnt=0 1173 local cdcnt=0
1328 local f= 1174 local f=
1352 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1198 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1353 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1199 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1354 export CDROM_SET=-1 1200 export CDROM_SET=-1
1355 for f in ${CDROM_CHECK_1//:/ } ; do 1201 for f in ${CDROM_CHECK_1//:/ } ; do
1356 ((++CDROM_SET)) 1202 ((++CDROM_SET))
1357 [[ -e ${CD_ROOT}/${f} ]] && break 1203 [[ -e ${CDROM_ROOT}/${f} ]] && break
1358 done 1204 done
1359 export CDROM_MATCH=${f} 1205 export CDROM_MATCH=${f}
1360 return 1206 return
1361 fi 1207 fi
1362 1208
1414 export CDROM_SET="" 1260 export CDROM_SET=""
1415 export CDROM_CURRENT_CD=0 1261 export CDROM_CURRENT_CD=0
1416 cdrom_load_next_cd 1262 cdrom_load_next_cd
1417} 1263}
1418 1264
1419# this is only used when you need access to more than one cd. 1265# @FUNCTION: cdrom_load_next_cd
1420# when you have finished using the first cd, just call this function. 1266# @DESCRIPTION:
1421# when it returns, CDROM_ROOT will be pointing to the second cd. 1267# Some packages are so big they come on multiple CDs. When you're done reading
1422# remember, you can only go forward in the cd chain, you can't go back. 1268# files off a CD and want access to the next one, just call this function.
1269# Again, all the messy details of user interaction are taken care of for you.
1270# Once this returns, just read the variable CDROM_ROOT for the location of the
1271# mounted CD. Note that you can only go forward in the CD list, so make sure
1272# you only call this function when you're done using the current CD.
1423cdrom_load_next_cd() { 1273cdrom_load_next_cd() {
1424 local var 1274 local var
1425 ((++CDROM_CURRENT_CD)) 1275 ((++CDROM_CURRENT_CD))
1426 1276
1427 unset CDROM_ROOT 1277 unset CDROM_ROOT
1444# displayed and we'll hang out here until: 1294# displayed and we'll hang out here until:
1445# (1) the file is found on a mounted cdrom 1295# (1) the file is found on a mounted cdrom
1446# (2) the user hits CTRL+C 1296# (2) the user hits CTRL+C
1447_cdrom_locate_file_on_cd() { 1297_cdrom_locate_file_on_cd() {
1448 local mline="" 1298 local mline=""
1449 local showedmsg=0 1299 local showedmsg=0 showjolietmsg=0
1450 1300
1451 while [[ -z ${CDROM_ROOT} ]] ; do 1301 while [[ -z ${CDROM_ROOT} ]] ; do
1452 local i=0 1302 local i=0
1453 local -a cdset=(${*//:/ }) 1303 local -a cdset=(${*//:/ })
1454 if [[ -n ${CDROM_SET} ]] ; then 1304 if [[ -n ${CDROM_SET} ]] ; then
1459 local dir=$(dirname ${cdset[${i}]}) 1309 local dir=$(dirname ${cdset[${i}]})
1460 local file=$(basename ${cdset[${i}]}) 1310 local file=$(basename ${cdset[${i}]})
1461 1311
1462 local point= node= fs= foo= 1312 local point= node= fs= foo=
1463 while read point node fs foo ; do 1313 while read point node fs foo ; do
1464 [[ " cd9660 iso9660 " != *" ${fs} "* ]] && \ 1314 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1465 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \ 1315 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1466 && continue 1316 && continue
1467 point=${point//\040/ } 1317 point=${point//\040/ }
1318 [[ ! -d ${point}/${dir} ]] && continue
1468 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue 1319 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1469 export CDROM_ROOT=${point} 1320 export CDROM_ROOT=${point}
1470 export CDROM_SET=${i} 1321 export CDROM_SET=${i}
1471 export CDROM_MATCH=${cdset[${i}]} 1322 export CDROM_MATCH=${cdset[${i}]}
1472 return 1323 return
1494 showedmsg=1 1345 showedmsg=1
1495 fi 1346 fi
1496 einfo "Press return to scan for the cd again" 1347 einfo "Press return to scan for the cd again"
1497 einfo "or hit CTRL+C to abort the emerge." 1348 einfo "or hit CTRL+C to abort the emerge."
1498 echo 1349 echo
1350 if [[ ${showjolietmsg} -eq 0 ]] ; then
1351 showjolietmsg=1
1352 else
1499 einfo "If you are having trouble with the detection" 1353 ewarn "If you are having trouble with the detection"
1500 einfo "of your CD, it is possible that you do not have" 1354 ewarn "of your CD, it is possible that you do not have"
1501 einfo "Joliet support enabled in your kernel. Please" 1355 ewarn "Joliet support enabled in your kernel. Please"
1502 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1356 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1357 ebeep 5
1358 fi
1503 read || die "something is screwed with your system" 1359 read || die "something is screwed with your system"
1504 done 1360 done
1505} 1361}
1506 1362
1363# @FUNCTION: strip-linguas
1364# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1365# @DESCRIPTION:
1507# Make sure that LINGUAS only contains languages that 1366# Make sure that LINGUAS only contains languages that
1508# a package can support 1367# a package can support. The first form allows you to
1509# 1368# specify a list of LINGUAS. The -i builds a list of po
1510# usage: strip-linguas <allow LINGUAS> 1369# files found in all the directories and uses the
1511# strip-linguas -i <directories of .po files> 1370# intersection of the lists. The -u builds a list of po
1512# strip-linguas -u <directories of .po files> 1371# files found in all the directories and uses the union
1513# 1372# of the lists.
1514# The first form allows you to specify a list of LINGUAS.
1515# The -i builds a list of po files found in all the
1516# directories and uses the intersection of the lists.
1517# The -u builds a list of po files found in all the
1518# directories and uses the union of the lists.
1519strip-linguas() { 1373strip-linguas() {
1520 local ls newls nols 1374 local ls newls nols
1521 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1375 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1522 local op=$1; shift 1376 local op=$1; shift
1523 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1377 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1524 local d f 1378 local d f
1525 for d in "$@" ; do 1379 for d in "$@" ; do
1526 if [[ ${op} == "-u" ]] ; then 1380 if [[ ${op} == "-u" ]] ; then
1527 newls=${ls} 1381 newls=${ls}
1528 else 1382 else
1529 newls="" 1383 newls=""
1530 fi 1384 fi
1531 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1385 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1532 if [[ ${op} == "-i" ]] ; then 1386 if [[ ${op} == "-i" ]] ; then
1533 hasq ${f} ${ls} && newls="${newls} ${f}" 1387 has ${f} ${ls} && newls="${newls} ${f}"
1534 else 1388 else
1535 hasq ${f} ${ls} || newls="${newls} ${f}" 1389 has ${f} ${ls} || newls="${newls} ${f}"
1536 fi 1390 fi
1537 done 1391 done
1538 ls=${newls} 1392 ls=${newls}
1539 done 1393 done
1540 else 1394 else
1542 fi 1396 fi
1543 1397
1544 nols="" 1398 nols=""
1545 newls="" 1399 newls=""
1546 for f in ${LINGUAS} ; do 1400 for f in ${LINGUAS} ; do
1547 if hasq ${f} ${ls} ; then 1401 if has ${f} ${ls} ; then
1548 newls="${newls} ${f}" 1402 newls="${newls} ${f}"
1549 else 1403 else
1550 nols="${nols} ${f}" 1404 nols="${nols} ${f}"
1551 fi 1405 fi
1552 done 1406 done
1553 [[ -n ${nols} ]] \ 1407 [[ -n ${nols} ]] \
1554 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1408 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1555 export LINGUAS=${newls:1} 1409 export LINGUAS=${newls:1}
1556} 1410}
1557 1411
1558# moved from kernel.eclass since they are generally useful outside of 1412# @FUNCTION: preserve_old_lib
1559# kernel.eclass -iggy (20041002) 1413# @USAGE: <libs to preserve> [more libs]
1560 1414# @DESCRIPTION:
1561# the following functions are useful in kernel module ebuilds, etc.
1562# for an example see ivtv or drbd ebuilds
1563
1564# set's ARCH to match what the kernel expects
1565set_arch_to_kernel() {
1566 i=10
1567 while ((i--)) ; do
1568 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1569 done
1570 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1571 case ${ARCH} in
1572 x86) export ARCH="i386";;
1573 amd64) export ARCH="x86_64";;
1574 hppa) export ARCH="parisc";;
1575 mips) export ARCH="mips";;
1576 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1577 *) export ARCH="${ARCH}";;
1578 esac
1579}
1580
1581# set's ARCH back to what portage expects
1582set_arch_to_portage() {
1583 i=10
1584 while ((i--)) ; do
1585 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1586 done
1587 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1588}
1589
1590# Jeremy Huddleston <eradicator@gentoo.org>:
1591# preserve_old_lib /path/to/libblah.so.0
1592# preserve_old_lib_notify /path/to/libblah.so.0
1593#
1594# These functions are useful when a lib in your package changes --library. Such 1415# These functions are useful when a lib in your package changes ABI SONAME.
1595# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1416# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1596# would break packages that link against it. Most people get around this 1417# would break packages that link against it. Most people get around this
1597# by using the portage SLOT mechanism, but that is not always a relevant 1418# by using the portage SLOT mechanism, but that is not always a relevant
1598# solution, so instead you can add the following to your ebuilds: 1419# solution, so instead you can call this from pkg_preinst. See also the
1599# 1420# preserve_old_lib_notify function.
1600# pkg_preinst() {
1601# ...
1602# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1603# ...
1604# }
1605#
1606# pkg_postinst() {
1607# ...
1608# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1609# ...
1610# }
1611
1612preserve_old_lib() { 1421preserve_old_lib() {
1613 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then 1422 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1614 eerror "preserve_old_lib() must be called from pkg_preinst() only" 1423 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1615 die "Invalid preserve_old_lib() usage" 1424 die "Invalid preserve_old_lib() usage"
1616 fi 1425 fi
1617 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]" 1426 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1427
1428 # let portage worry about it
1429 has preserve-libs ${FEATURES} && return 0
1618 1430
1619 local lib dir 1431 local lib dir
1620 for lib in "$@" ; do 1432 for lib in "$@" ; do
1621 [[ -e ${ROOT}/${lib} ]] || continue 1433 [[ -e ${ROOT}/${lib} ]] || continue
1622 dir=${lib%/*} 1434 dir=${lib%/*}
1624 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed" 1436 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1625 touch "${D}"/${lib} 1437 touch "${D}"/${lib}
1626 done 1438 done
1627} 1439}
1628 1440
1441# @FUNCTION: preserve_old_lib_notify
1442# @USAGE: <libs to notify> [more libs]
1443# @DESCRIPTION:
1444# Spit helpful messages about the libraries preserved by preserve_old_lib.
1629preserve_old_lib_notify() { 1445preserve_old_lib_notify() {
1630 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then 1446 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1631 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only" 1447 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1632 die "Invalid preserve_old_lib_notify() usage" 1448 die "Invalid preserve_old_lib_notify() usage"
1633 fi 1449 fi
1450
1451 # let portage worry about it
1452 has preserve-libs ${FEATURES} && return 0
1634 1453
1635 local lib notice=0 1454 local lib notice=0
1636 for lib in "$@" ; do 1455 for lib in "$@" ; do
1637 [[ -e ${ROOT}/${lib} ]] || continue 1456 [[ -e ${ROOT}/${lib} ]] || continue
1638 if [[ ${notice} -eq 0 ]] ; then 1457 if [[ ${notice} -eq 0 ]] ; then
1642 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1461 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1643 ewarn "in order to remove these old dependencies. If you do not have this" 1462 ewarn "in order to remove these old dependencies. If you do not have this"
1644 ewarn "helper program, simply emerge the 'gentoolkit' package." 1463 ewarn "helper program, simply emerge the 'gentoolkit' package."
1645 ewarn 1464 ewarn
1646 fi 1465 fi
1466 # temp hack for #348634 #357225
1467 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1647 ewarn " # revdep-rebuild --library ${lib##*/}" 1468 ewarn " # revdep-rebuild --library '${lib}'"
1648 done 1469 done
1470 if [[ ${notice} -eq 1 ]] ; then
1471 ewarn
1472 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1473 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1474 for lib in "$@" ; do
1475 ewarn " # rm '${lib}'"
1476 done
1477 fi
1649} 1478}
1650 1479
1651# Hack for people to figure out if a package was built with 1480# @FUNCTION: built_with_use
1652# certain USE flags
1653#
1654# Usage: built_with_use [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1481# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1655# ex: built_with_use xchat gtk2 1482# @DESCRIPTION:
1656# 1483#
1657# Flags: -a all USE flags should be utilized 1484# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1658# -o at least one USE flag should be utilized 1485#
1659# --missing peform the specified action if the flag is not in IUSE (true/false/die) 1486# A temporary hack until portage properly supports DEPENDing on USE
1660# --hidden USE flag we're checking is hidden expanded so it isnt in IUSE 1487# flags being enabled in packages. This will check to see if the specified
1661# Note: the default flag is '-a' 1488# DEPEND atom was built with the specified list of USE flags. The
1489# --missing option controls the behavior if called on a package that does
1490# not actually support the defined USE flags (aka listed in IUSE).
1491# The default is to abort (call die). The -a and -o flags control
1492# the requirements of the USE flags. They correspond to "and" and "or"
1493# logic. So the -a flag means all listed USE flags must be enabled
1494# while the -o flag means at least one of the listed IUSE flags must be
1495# enabled. The --hidden option is really for internal use only as it
1496# means the USE flag we're checking is hidden expanded, so it won't be found
1497# in IUSE like normal USE flags.
1498#
1499# Remember that this function isn't terribly intelligent so order of optional
1500# flags matter.
1662built_with_use() { 1501built_with_use() {
1663 local hidden="no" 1502 local hidden="no"
1664 if [[ $1 == "--hidden" ]] ; then 1503 if [[ $1 == "--hidden" ]] ; then
1665 hidden="yes" 1504 hidden="yes"
1666 shift 1505 shift
1695 die) die "Unable to determine what USE flags $PKG was built with";; 1534 die) die "Unable to determine what USE flags $PKG was built with";;
1696 esac 1535 esac
1697 fi 1536 fi
1698 1537
1699 if [[ ${hidden} == "no" ]] ; then 1538 if [[ ${hidden} == "no" ]] ; then
1700 local IUSE_BUILT=$(<${IUSEFILE}) 1539 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1701 # Don't check USE_EXPAND #147237 1540 # Don't check USE_EXPAND #147237
1702 local expand 1541 local expand
1703 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do 1542 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1704 if [[ $1 == ${expand}_* ]] ; then 1543 if [[ $1 == ${expand}_* ]] ; then
1705 expand="" 1544 expand=""
1706 break 1545 break
1707 fi 1546 fi
1708 done 1547 done
1709 if [[ -n ${expand} ]] ; then 1548 if [[ -n ${expand} ]] ; then
1710 if ! has $1 ${IUSE_BUILT} ; then 1549 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1711 case ${missing_action} in 1550 case ${missing_action} in
1712 true) return 0;; 1551 true) return 0;;
1713 false) return 1;; 1552 false) return 1;;
1714 die) die "$PKG does not actually support the $1 USE flag!";; 1553 die) die "$PKG does not actually support the $1 USE flag!";;
1715 esac 1554 esac
1727 shift 1566 shift
1728 done 1567 done
1729 [[ ${opt} = "-a" ]] 1568 [[ ${opt} = "-a" ]]
1730} 1569}
1731 1570
1571# @FUNCTION: epunt_cxx
1572# @USAGE: [dir to scan]
1573# @DESCRIPTION:
1732# Many configure scripts wrongly bail when a C++ compiler 1574# Many configure scripts wrongly bail when a C++ compiler could not be
1733# could not be detected. #73450 1575# detected. If dir is not specified, then it defaults to ${S}.
1576#
1577# http://bugs.gentoo.org/73450
1734epunt_cxx() { 1578epunt_cxx() {
1735 local dir=$1 1579 local dir=$1
1736 [[ -z ${dir} ]] && dir=${S} 1580 [[ -z ${dir} ]] && dir=${S}
1737 ebegin "Removing useless C++ checks" 1581 ebegin "Removing useless C++ checks"
1738 local f 1582 local f
1739 for f in $(find ${dir} -name configure) ; do 1583 find "${dir}" -name configure | while read f ; do
1740 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1584 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1741 done 1585 done
1742 eend 0 1586 eend 0
1743} 1587}
1744 1588
1745# make a wrapper script ... 1589# @FUNCTION: make_wrapper
1746# NOTE: this was originally games_make_wrapper, but I noticed other places where 1590# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1747# this could be used, so I have moved it here and made it not games-specific 1591# @DESCRIPTION:
1748# -- wolf31o2 1592# Create a shell wrapper script named wrapper in installpath
1749# $1 == wrapper name 1593# (defaults to the bindir) to execute target (default of wrapper) by
1750# $2 == binary to run 1594# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1751# $3 == directory to chdir before running binary 1595# libpaths followed by optionally changing directory to chdir.
1752# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1753# $5 == path for wrapper
1754make_wrapper() { 1596make_wrapper() {
1755 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1597 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1756 local tmpwrapper=$(emktemp) 1598 local tmpwrapper=$(emktemp)
1757 # We don't want to quote ${bin} so that people can pass complex 1599 # We don't want to quote ${bin} so that people can pass complex
1758 # things as $bin ... "./someprog --args" 1600 # things as $bin ... "./someprog --args"
1768fi 1610fi
1769exec ${bin} "\$@" 1611exec ${bin} "\$@"
1770EOF 1612EOF
1771 chmod go+rx "${tmpwrapper}" 1613 chmod go+rx "${tmpwrapper}"
1772 if [[ -n ${path} ]] ; then 1614 if [[ -n ${path} ]] ; then
1615 (
1773 exeinto "${path}" 1616 exeinto "${path}"
1774 newexe "${tmpwrapper}" "${wrapper}" 1617 newexe "${tmpwrapper}" "${wrapper}"
1618 ) || die
1775 else 1619 else
1776 newbin "${tmpwrapper}" "${wrapper}" 1620 newbin "${tmpwrapper}" "${wrapper}" || die
1777 fi 1621 fi
1778} 1622}
1623
1624# @FUNCTION: path_exists
1625# @USAGE: [-a|-o] <paths>
1626# @DESCRIPTION:
1627# Check if the specified paths exist. Works for all types of paths
1628# (files/dirs/etc...). The -a and -o flags control the requirements
1629# of the paths. They correspond to "and" and "or" logic. So the -a
1630# flag means all the paths must exist while the -o flag means at least
1631# one of the paths must exist. The default behavior is "and". If no
1632# paths are specified, then the return value is "false".
1633path_exists() {
1634 local opt=$1
1635 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1636
1637 # no paths -> return false
1638 # same behavior as: [[ -e "" ]]
1639 [[ $# -eq 0 ]] && return 1
1640
1641 local p r=0
1642 for p in "$@" ; do
1643 [[ -e ${p} ]]
1644 : $(( r += $? ))
1645 done
1646
1647 case ${opt} in
1648 -a) return $(( r != 0 )) ;;
1649 -o) return $(( r == $# )) ;;
1650 esac
1651}
1652
1653# @FUNCTION: in_iuse
1654# @USAGE: <flag>
1655# @DESCRIPTION:
1656# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1657# as necessary.
1658#
1659# Note that this function should not be used in the global scope.
1660in_iuse() {
1661 debug-print-function ${FUNCNAME} "${@}"
1662 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1663
1664 local flag=${1}
1665 local liuse=( ${IUSE} )
1666
1667 has "${flag}" "${liuse[@]#[+-]}"
1668}
1669
1670# @FUNCTION: use_if_iuse
1671# @USAGE: <flag>
1672# @DESCRIPTION:
1673# Return true if the given flag is in USE and IUSE.
1674#
1675# Note that this function should not be used in the global scope.
1676use_if_iuse() {
1677 in_iuse $1 || return 1
1678 use $1
1679}
1680
1681# @FUNCTION: usex
1682# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1683# @DESCRIPTION:
1684# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1685# otherwise echo [false output][false suffix] (defaults to "no").
1686usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963

Legend:
Removed from v.1.279  
changed lines
  Added in v.1.369

  ViewVC Help
Powered by ViewVC 1.1.20